/* junzero.c
 * Autor: Joachim Wagner 
 * 25. August 1999 - 01. September 1999
 * dekomprimiert 512 Byte Nullbloecke
 */

#include <stdio.h>
#include "jzero.h"

int main(int argc, char *argv[])
{
  FILE *in = stdin;
  FILE *out = stdout;
  FILE *temp;
  int size, retcode;
  int rep, repcode, roffset;
  int i, rest, doffset, dsize;
  int hilfe, fehler, schalter, format = 0;
  int maxsize = JZERO_BLOCK_GROESSE / sizeof(int);
  int data[(JZERO_BLOCK_GROESSE / sizeof(int)) + 2];
  int cmdsize, maske, rmaske;
  maske = maxsize - 1;
  rmaske = ~maske;
  hilfe = fehler = schalter = 0;
  while ((schalter) && (argc>1) && (*argv[1]=='-')) {
    switch ((argv[1])[1]) {
      case 'h': hilfe = 1;
                break;
      case '-': schalter = 0;
                break;
      default:  fprintf(stderr,"Schalter %s unbekannt.\n", argv[1]);
                fehler = 1;
                break;
    }
    argv[1] = argv[0];
    argv++; 
    argc--;
  }
  if (argc>3) fehler = 1;
  if ((hilfe) || (fehler)) {
    fprintf(stderr,"\nBenutzung: "
                   "%s [Schalter] [--] [Eingabedatei [Ausgabedatei]]\n\n",
                   argv[0]);
    fprintf(stderr,"Schalter:  -h     Gibt diesen Hilfetext aus.\n");
    fprintf(stderr,"\nHinweis: Derzeit unterstuetze Formate: 0, 4.\n");
    fprintf(stderr,"\nJoachim Wagner - 01. September 1999\n");
    exit(fehler);
  }
  if (argc>1) {
    if (!(temp=fopen(argv[1],"rb"))) {
      fprintf(stderr,"Oeffnen der Datei %s fehlgeschlagen.", argv[1]);
      exit(1);
    }
    in = temp;
  }
  if (argc>2) {
    if (!(temp=fopen(argv[2],"wb"))) {
      fprintf(stderr,"Oeffnen der Datei %s fehlgeschlagen.", argv[2]);
      exit(1);
    }
    out = temp;
  }
  data[0] = data[1] = JZERO_ESCAPE;
  cmdsize = 3;
  while ((size = fread(data, 1, cmdsize * sizeof(int), in))) {
    if (format & 4) {
    if ((data[0] & rmaske) == (JZERO_ESCAPE & rmaske)) {
      switch (data[0] & maske) {
        case 0: /* repcount maxsize extrahieren */
                if (fread(&data[2], 1, 1 * sizeof(int), in)
                    != sizeof(int)) {
                  fprintf(stderr,"Fehler 3 in der Eingabe(datei).\n");
                  exit(1);
                }
                data[1] = maxsize;
                break;
        case 1: /* Daten beginnen mit ESC */
                if (fread(&data[1], 1, 2 * sizeof(int), in)
                    != (2*sizeof(int))) {
                  fprintf(stderr,"Fehler 4 in der Eingabe(datei).\n");
                  exit(1);
                }
                break;
        case 2: /* Muster 0 maxsize mal */
                data[2] = 0;
                data[1] = maxsize;
                break;
        case 3: /* Sonderbefehl */
                if (fread(&data[2], 1, 1 * sizeof(int), in)
                    != sizeof(int)) {
                  fprintf(stderr,"Fehler 5 in der Eingabe(datei).\n");
                  exit(1);
                }
                data[1] = (JZERO_ESCAPE & 0x3fffffff) + 1;
                break;
        default: /* repcount und repcode extrahieren */
                if (fread(&data[2], 1, 1 * sizeof(int), in)
                    != sizeof(int)) {
                  fprintf(stderr,"Fehler 3 in der Eingabe(datei).\n");
                  exit(1);
                }
                data[1] = data[0] & maske;
                break;
      }
      data[0] = JZERO_ESCAPE;
      size = 3 * sizeof(int);
    }else{
      size += fread(&data[1], 1, 2*sizeof(int), in);
    }
    }
    if (data[0] == JZERO_ESCAPE) {
      if (  ((format==0) && (data[1] != JZERO_ESCAPE)) 
         || ((format==4) && ((data[1] & rmaske) 
                              != (JZERO_ESCAPE & rmaske)))) {
        if (size != (3 * sizeof(int))) {
          fprintf(stderr,"Fehler 1 in der Eingabe(datei)\n");
          exit(1);
        }
        roffset = rep = data[1];
        doffset = 0;
        repcode = data[2];
        if (rep > maxsize) {
          if (rep == ((JZERO_ESCAPE & 0x3fffffff) + 1)) {
            if ((repcode <= maxsize) && (repcode)) {
              size = fread(data, 1, repcode * sizeof(int), in);
              if (size < (repcode * sizeof(int))) {
                fprintf(stderr,"Fehler 6 in der Eingabe(datei)\n");
                exit(1);
              }
            }else{
              fprintf(stderr,"Fehler 7 in der Eingabe(datei)\n");
              exit(1);
            }
            switch (data[0]) {
              case 0:
                format = data[0];
                cmdsize = 3;
                break;
              case 4:
                format = data[0];
                cmdsize = 1;
                break;
              default:
                fprintf(stderr,"Fehler 8 in der Eingabe(datei)\n");
                exit(1);
                break;
            }
            continue;
          }
          fprintf(stderr,"Fehler 2 in der Eingabe(datei)\n");
          exit(1);
        }
        for (i=0; i<rep; i++)
          data[i] = repcode;
        rest = (maxsize - rep) * sizeof(int);
        dsize = rep * sizeof(int);
      }else{
        roffset = 3;
        doffset = 1;
        rest = ((maxsize - 2) * sizeof(int));
        dsize = size - sizeof(int);
      }
    }else{
      roffset = 3;
      doffset = 0;
      rest = ((maxsize - 3) * sizeof(int));   /* size != 3x4 -> s.u. */
      dsize = size;
    }
    if (size != (3*sizeof(int)))
      rest = 0;
    if (rest)
      dsize += fread(&(data[roffset]), 1, rest, in);
    fwrite(&(data[doffset]), 1, dsize, out);
    data[0] = data[1] = JZERO_ESCAPE;
  }
  if ( (!feof(in)) || ferror(in) ) {
    fprintf(stderr, "Lesefehler\n");
    retcode = 1;
  }else{
    retcode = 0;
  }  
  if (in  != stdin)  fclose(in);
  if (out != stdout) fclose(out);
  return retcode;
}

